//---------------------------------------------------------------------------


#pragma hdrstop

#include "uGrab.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
//---------------------------------------------------------------------------
_Grab::_Grab(TForm *fm)
{
   TForm *Grab=0;
   m_slWnd = new TStringList;
   for (int i=0;i<grabNum ;i++){
      Grab = new TForm(fm);
      m_fm[i] = Grab;
      m_slWnd->AddObject("Grab"+IntToStr(i), (TObject *)Grab);
   }
   fnInit();
}
//--------------
void _Grab::fnInit()
{
   TForm *Grab;
   m_FramWnd = (HWND)-1;
   m_bFramed = false;
   m_iBevelWith = 4;
   m_gb = grabNon;
   m_ptFram.x=0;
   m_ptFram.y=0;
   SetRect(&m_Rt,0,0,0,0);
   for (int i=0;i<m_slWnd->Count ;i++){
      Grab = (TForm *)m_slWnd->Objects[i];
      Grab->Width  = m_iBevelWith;
      Grab->Height = m_iBevelWith;
      Grab->Caption = "Grab"+IntToStr(i);
      Grab->Color = clBlack;
      Grab->BorderStyle = bsNone;
      Grab->Visible = false;
   }
   m_fm[grabT]->Cursor = crSizeNS;
   m_fm[grabB]->Cursor = crSizeNS;
   m_fm[grabL]->Cursor = crSizeWE;
   m_fm[grabR]->Cursor = crSizeWE;
   m_fm[grabTL]->Cursor = crSizeNWSE;
   m_fm[grabBR]->Cursor = crSizeNWSE;
   m_fm[grabTR]->Cursor = crSizeNESW;
   m_fm[grabBL]->Cursor = crSizeNESW;
}
//-----------------
_Grab::~_Grab()
{
   for (int i=0;i<grabNum ;i++)
      delete m_fm[i];
   delete m_slWnd;

}
//------------------
void _Grab::fnUnFram()
{
   m_bFramed = false;
   m_ptFram.x=0;
   m_ptFram.y=0;
   if(m_gb == grabNon){
      fnDrop();
      fnAttach();
   }
   if(IsWindow(m_FramWnd))
      GetWindowRect(m_FramWnd, &m_Rt);
}
//----------------------
void _Grab::fnFram(HWND hWnd, POINT ptHit)
{
   char szCpn[255]="";
   TRect Rect;
   int iTopT, iTopM, iTopB;
   int iLeftL, iLeftM, iLeftR;

   m_bFramed = true;
   m_ptFram = ptHit;
   if(IsWindow(hWnd)){
      if(GetParent(hWnd)==0 || hWnd== (HWND)Application->MainForm->Handle){
         fnInit();
         return;
      }

      GetWindowText(hWnd, szCpn, 254);
      m_gb = m_slWnd->IndexOf(StrPas(szCpn));
      GetWindowRect(hWnd, &Rect);
      if(m_gb == grabNon){
         m_Rt = Rect;
         m_FramWnd = hWnd;
         iTopT = Rect.top;
         iTopB = Rect.Bottom-m_iBevelWith;
         iLeftL = Rect.left ;
         iLeftR = Rect.Right-m_iBevelWith;
         MoveWindow(m_fm[grabT]->Handle, iLeftL, iTopT, Rect.Width(), m_iBevelWith, true);
         MoveWindow(m_fm[grabB]->Handle, iLeftL, iTopB, Rect.Width(), m_iBevelWith, true);
         MoveWindow(m_fm[grabL]->Handle, iLeftL, iTopT, m_iBevelWith, Rect.Height(), true);
         MoveWindow(m_fm[grabR]->Handle, iLeftR, iTopT, m_iBevelWith, Rect.Height(), true);
         for (int i=0;i<4 ;i++){
            m_fm[i]->Color = clWindow;
            m_fm[i]->Visible = true;
         }
         for (int i=4;i<grabNum ;i++)
            m_fm[i]->Visible = false;
      }
   }
}
//----------------
void _Grab::fnFramDrag(POINT pt)
{
   TRect Rt;
   int iTopT, iTopB;
   int iLeftL, iLeftR;
   POINT rtPt;
   int iWOfx = pt.x - m_ptFram.x;;
   int iHOfx = pt.y - m_ptFram.y;

   if(IsWindow(m_FramWnd) && m_bFramed){
      switch (m_gb){
      case grabNon:
         iLeftL = m_Rt.Left   - (m_ptFram.x - pt.x);
         iLeftR = m_Rt.Right  - (m_ptFram.x - pt.x) - m_iBevelWith;
         iTopT  = m_Rt.top    - (m_ptFram.y - pt.y);
         iTopB  = m_Rt.Bottom - (m_ptFram.y - pt.y) - m_iBevelWith;
         MoveWindow(m_fm[grabT]->Handle, iLeftL, iTopT, m_fm[grabT]->Width, m_fm[grabT]->Height, true);
         MoveWindow(m_fm[grabB]->Handle, iLeftL, iTopB, m_fm[grabB]->Width, m_fm[grabB]->Height, true);
         MoveWindow(m_fm[grabL]->Handle, iLeftL, iTopT, m_fm[grabL]->Width, m_fm[grabL]->Height, true);
         MoveWindow(m_fm[grabR]->Handle, iLeftR, iTopT, m_fm[grabR]->Width, m_fm[grabR]->Height, true);
      break;
      case grabT:
         rtPt.x = m_Rt.Left;
         rtPt.y = m_Rt.Top + iHOfx;
         ScreenToClient(GetParent(m_FramWnd), &rtPt);
         MoveWindow(m_FramWnd, rtPt.x, rtPt.y, m_Rt.Width(), m_Rt.Height() - iHOfx, true);
         fnAttach();
      break;
      case grabB:
         rtPt.x = m_Rt.Left;
         rtPt.y = m_Rt.Top;
         ScreenToClient(GetParent(m_FramWnd), &rtPt);
         MoveWindow(m_FramWnd, rtPt.x, rtPt.y, m_Rt.Width(), m_Rt.Height() +iHOfx, true);
         fnAttach();
      break;
      case grabL:
         rtPt.x = m_Rt.Left+iWOfx;
         rtPt.y = m_Rt.Top;
         ScreenToClient(GetParent(m_FramWnd), &rtPt);
         MoveWindow(m_FramWnd, rtPt.x, rtPt.y, m_Rt.Width()-iWOfx, m_Rt.Height(), true);
         fnAttach();
      break;
      case grabR:
         rtPt.x = m_Rt.Left;
         rtPt.y = m_Rt.Top;
         ScreenToClient(GetParent(m_FramWnd), &rtPt);
         MoveWindow(m_FramWnd, rtPt.x, rtPt.y, m_Rt.Width()+iWOfx, m_Rt.Height(), true);
         fnAttach();
      break;
      case grabTL:
         rtPt.x = m_Rt.Left+iWOfx;
         rtPt.y = m_Rt.Top + iHOfx;
         ScreenToClient(GetParent(m_FramWnd), &rtPt);
         MoveWindow(m_FramWnd, rtPt.x, rtPt.y, m_Rt.Width()-iWOfx, m_Rt.Height()-iHOfx, true);
         fnAttach();
      break;
      case grabTR:
         rtPt.x = m_Rt.Left;
         rtPt.y = m_Rt.Top + iHOfx;
         ScreenToClient(GetParent(m_FramWnd), &rtPt);
         MoveWindow(m_FramWnd, rtPt.x, rtPt.y, m_Rt.Width()+iWOfx, m_Rt.Height()-iHOfx, true);
         fnAttach();
      break;
      case grabBL:
         rtPt.x = m_Rt.Left+iWOfx;
         rtPt.y = m_Rt.Top ;
         ScreenToClient(GetParent(m_FramWnd), &rtPt);
         MoveWindow(m_FramWnd, rtPt.x, rtPt.y, m_Rt.Width()-iWOfx, m_Rt.Height()+iHOfx, true);
         fnAttach();
      break;
      case grabBR:
         rtPt.x = m_Rt.Left;
         rtPt.y = m_Rt.Top ;
         ScreenToClient(GetParent(m_FramWnd), &rtPt);
         MoveWindow(m_FramWnd, rtPt.x, rtPt.y, m_Rt.Width()+iWOfx, m_Rt.Height()+iHOfx, true);
         fnAttach();
      break;
      }
   }
}
//-----------------
void _Grab::fnDrop()
{
   TRect Rect;
   POINT pt;
   if(IsWindow(m_FramWnd)){
      GetWindowRect(m_FramWnd, &Rect);
      pt.x = m_fm[grabT]->Left;
      pt.y = m_fm[grabT]->Top;
      ScreenToClient(GetParent(m_FramWnd), &pt);
      MoveWindow(m_FramWnd, pt.x, pt.y, Rect.Width(), Rect.Height(), true);
   }
}
//------------------
void _Grab::fnAttach()
{
   TRect Rect;
   int iTopT, iTopM, iTopB;
   int iLeftL, iLeftM, iLeftR;
   if(IsWindow(m_FramWnd)){
      GetWindowRect(m_FramWnd, &Rect);
      for (int i=0;i<grabNum ;i++){
         SetWindowPos(m_fm[i]->Handle, HWND_TOPMOST, 0,0,0,0, SWP_SHOWWINDOW);
         m_fm[i]->Color = clBlack;
         m_fm[i]->Visible = true;
      }
      iTopT = Rect.top - m_iBevelWith/2;
      iTopM = Rect.Top + (Rect.Height()/2) -m_iBevelWith/2;
      iTopB = Rect.Bottom - m_iBevelWith/2;
      iLeftL = Rect.left - m_iBevelWith/2;
      iLeftM = Rect.left + Rect.Width()/2 - m_iBevelWith/2;
      iLeftR = Rect.Right - m_iBevelWith/2;

      MoveWindow(m_fm[grabT]->Handle,  iLeftM, iTopT, m_iBevelWith, m_iBevelWith, true);
      MoveWindow(m_fm[grabB]->Handle,  iLeftM, iTopB, m_iBevelWith, m_iBevelWith, true);
      MoveWindow(m_fm[grabL]->Handle,  iLeftL, iTopM, m_iBevelWith, m_iBevelWith, true);
      MoveWindow(m_fm[grabR]->Handle,  iLeftR, iTopM, m_iBevelWith, m_iBevelWith, true);
      MoveWindow(m_fm[grabTL]->Handle, iLeftL, iTopT, m_iBevelWith, m_iBevelWith, true);
      MoveWindow(m_fm[grabTR]->Handle, iLeftR, iTopT, m_iBevelWith, m_iBevelWith, true);
      MoveWindow(m_fm[grabBL]->Handle, iLeftL, iTopB, m_iBevelWith, m_iBevelWith, true);
      MoveWindow(m_fm[grabBR]->Handle, iLeftR, iTopB, m_iBevelWith, m_iBevelWith, true);
   }
}
//--------------------------------------------
